import uuid
import datetime

class Database():
  def __init__(self) -> None:
    self.message = []
    self.log = []

  def add(self,id):
    message = input("Enter message:")
    msg_id = uuid.uuid4()
    self.message.append({"id":msg_id,"user":id,"message":message})
    self.log.append(f"[{datetime.datetime.now()}] ADD - {msg_id}:{id}")

  def update(self,id):
    # show message
    i = 0
    self.user_msg = []
    for message in self.message:
      if(message.user==id):
        self.user_msg.append(message)
    for msg in self.user_msg:
        print(f"{i}. {msg.id} - {msg.message}")
        i += 1
    msg_id = input("Masukkan id pesan yang ingin diubah:")
    new_msg = input("Masukkan isi pesan baru")
    # validasi id user 
    for j in range(len(self.message)):
      if(self.message[j].id == msg_id and self.message[j].user==id):
        self.message[j].message = new_msg
        self.log.append(f"[{datetime.datetime.now()}] UPDATE - {msg_id}:{id}")
        break

  def delete(self,id):
    # show message
    i = 0
    self.user_msg = []
    for message in self.message:
      if(message.user==id):
        self.user_msg.append(message)
    for msg in self.user_msg:
        print(f"{i}. {msg.id} - {msg.message}")
        i += 1
    msg_id = input("Masukkan id pesan yang ingin dihapus:")
    # validasi id user 
    for j in range(len(self.message)):
      if(self.message[j].id == msg_id and self.message[j].user==id):
        self.message.pop(j)
        self.log.append(f"[{datetime.datetime.now()}] DELETE - {msg_id}:{id}")
        break

  def read(self,id):
    # show message
    i = 0
    self.user_msg = []
    for message in self.message:
      if(message.user==id):
        self.user_msg.append(message)
    for msg in self.user_msg:
        print(f"{i}. {msg.id} - {msg.message}")
        i += 1
    self.log.append(f"[{datetime.datetime.now()}] GET - {id}")

  def monitor(self,id):
    self.log.append(f"[{datetime.datetime.now()}] MONITOR - {id}")
    for log in self.log:
      print(log)

class ACL():
  def __init__(self) -> None:
    self.users = {uuid.uuid4():{"name":"admin","password":hash("fnifhu4i3fh43"),"role":"admin"}}
    self.active_users_id = {}

  def login(self):
    name = input("Enter name:")
    password = input("Enter password:")
    # cek jika users ada
    user_id = None
    for i,(id,user) in enumerate(self.users.items()):
      if user.name==name and hash(password) == user.password:
        user_id = id
        self.active_users_id.add(id)
        break
    if(user_id!=None):
      program.dashboard(user_id)

  def register(self):
    name = input("Enter name:")
    password = input("Enter password:")
    id = uuid.uuid4()
    self.users[id] = {"name":name,"password":hash(password),"role":"user"}
    program.dashboard(id)

class Program():
  def __init__(self) -> None:
    pass

  def dashboard(self,user_id):
    print("Choose Action:")
    print("1. Add Message")
    print("2. Read Message")
    print("3. Edit Message")
    print("4. Delete Message")
    if(acl.users[user_id]["role"]=="admin"):
      print("5. Monitor User Action")
    choice = int(input("Enter Action:"))
    if(choice==1):
      db.add(user_id)
    elif choice == 2:
      db.read(user_id)
    elif choice == 3:
      db.update(user_id)
    elif choice == 4:
      db.delete(user_id)
    elif choice == 5:
      db.monitor(user_id)
    else:
      return "Error"    
db = Database()
acl = ACL()
program = Program()

if __name__=="__main__":
  print("Welcome. Choose your action: ")
  print("1. Login")
  print("2. Register")
  choice = int(input())
  if choice == 1:
    acl.login()
  else:
    acl.register()
