from .Const import PATH_SEPARATOR

class FileInformation():
  def __init__(self,name,path,dependency_list,method_list):
    self.name:str = name
    self.path:str = path
    self.dependency_list:list = dependency_list
    self.method_list:list = method_list

  def __repr__(self) -> str:
    return self.__str__()
  
  def __str__(self) -> str:
    return f"FileInformation(name={self.name},path={self.path},dependency_list=[{len(self.dependency_list)} item],method_list=[{len(self.method_list)} item])"
  
class DependencyManager():
  def __init__(self) -> None:
    self.informations = []

  def add(self,information):
    for info in self.informations:
      if info.name == information.name and info.path == information.path:
        return 
    # Belum ada
    self.informations.append(information)

  def get(self,path:str)->FileInformation|None:
    name = path.split(PATH_SEPARATOR)[-1]
    for info in self.informations:
      if info.name == name and info.path == path:
        return info
    return None
  
  def __repr__(self) -> str:
    return self.__str__()
  
  def __str__(self) -> str:
    return f"DependencyManager(informations={self.informations})"

