class ElementContext():
  def __init__(self,name:str,type:str,location:str,context:list[str]) -> None:
    self.name:str = name
    self.type:str = type
    self.location:str = location
    self.cfg = None
    self.context:list[str] = context

  def set_cfg(self,cfg):
    self.cfg = cfg

  def __repr__(self) -> str:
    return self.__str__()
  
  def __str__(self) -> str:
    kongteks = "" if self.context==None else ",".join(self.context)
    return f"{self.type}::{self.name}@{self.location}({kongteks})"
  
  def get_base_element_name(self)->str:
    if self.type=='library':
      if self.context:
        return f'{",".join(self.context)} from library {self.name.split(" ")[1]}'
      elif "from" in self.name:
        parts = self.name.split("from")
        return f"{parts[1].strip()} from library {parts[0].strip()}"
      return f"library {self.name.split('import')[1].strip()}"
    return self.name.split("(")[0]