import subprocess
import re

class CFGGenerator():
  def __init__(self) -> None:
    self.CFG_PARSE_CMD = '.\src\lib\joern\joern-parse tmp/'
    self.CFG_SAVE_CMD = '.\src\lib\joern\joern-export --repr cfg --out tmp/cfg/'
  
  def generate_cfg(self,file_dir:str):
    # sanitasi folder name
    folder_name = self.sanitize_filename(file_dir)
    # buat cfg
    exec = subprocess.run(self.CFG_PARSE_CMD+folder_name,shell=True) # konteks lokasinya tergantung CWD terminal yang jalan
    # simpan cfg
    exec = subprocess.run(self.CFG_SAVE_CMD+folder_name,shell=True) # konteks lokasinya tergantung CWD terminal yang jalan

  def sanitize_filename(self,file_name):
    # remove &, | , ;, {},()
    return re.sub('[&|;{}()]','',file_name)