from zipfile import ZipFile
import uuid
import os
class FileParser():
  def __init__(self,archive_path) -> None:
    self.archive_path = archive_path
    self.folder_path = None
    self.source_files = []
    self.supported_extensions = os.getenv("SUPPORTED_EXTENSION").split("|")
    self.folder_name = ""

  def load(self):
    #unzip file
    self.unzip()
    # simpan reference ke file terkait
    for root, dirs, files in os.walk(self.folder_path):
      for file in files:
        if(self.is_source_code_supported(file)):
          self.source_files.append(f"{root}\\{file}")
    return self.source_files

  def unzip(self):
    with ZipFile(self.archive_path,'r') as zipObject:
      # get archive file name
      try:
        self.folder_name = f"extract-{os.path.basename(self.archive_path).split('.')[0]}"
      except:
        self.folder_name = f"extract-{uuid.uuid4()}"
      #get the folder path
      folder = os.path.join(os.path.dirname(self.archive_path),self.folder_name)
      self.folder_path = folder
      zipObject.extractall(folder)

  def is_source_code_supported(self,filename):
    extension = filename.split(".")[-1].lower()
    return extension in self.supported_extensions
  


    