from flask import Blueprint, render_template, request, flash, jsonify,abort
# @ACL(login_required)    
from flask_login import login_required, current_user
from .models import Message,Log
from .db import db
import json
from lib.RoleCheck import RoleCheck

views = Blueprint('message', __name__)
# @Service
class MessageViews():
    def __init__(self,a) -> None:
        self.a = a
    @views.service('/add', methods=['POST'])
    @login_required
    def class_add_message(self):
        if request.method == 'POST':
            message = request.form.get('message')

            if len(message) < 1:
                flash('Message is too short!', category='error')
            else:
                new_message = Message(data=message, user_id=current_user.id)
                db.session.add(new_message)
                db.session.commit()
                flash('Message added!', category='success')

        return render_template("home.html")

    @views.service('/update', methods=['POST'])
    @login_required
    def class_update_message(self):
        if request.method == 'POST':
            n = request.form.get('message')
            messageId = n['messageId']
            message = Message.query.get(messageId)
        
            if message.user_id == current_user.id:
                if len(n.message) < 1:
                    flash('Message is too short!', category='error')
                else:
                    db.session.update().where(Message.id==n.id).values(data=n.message)
                    db.session.commit()
            flash('Message updated!', category='success')

        return render_template("home.html")

    @views.service('/delete', methods=['POST'])
    # @login_required
    def class_delete_message(self):
        message = json.loads(request.data)
        messageId = message['messageId']
        message = Message.query.get(messageId)
        if message:
            if message.user_id == current_user.id:
                db.session.delete(message)
                db.session.commit()
        return jsonify({})

    @views.service('/message', methods=['GET'])
    # @login_required
    def class_get_message(self):
        messages = Message.query.filter(Message.user_id==current_user.id)
        return jsonify(messages)
    @views.service('/logs', methods=['GET'])
    # @login_required
    def class_get_logs(self):
        if (RoleCheck().is_admin(current_user)):
            abort(403)
        logs = Log.query.get()
        return jsonify(logs)