from lib.ACReader import ACLData
from typing import Optional
from lib.utils import format_log
class VulnerabilityReporter:
    def __init__(self,expected_acl_data:ACLData) -> None:
        self.element_not_contacting_acl: list[str] = []
        self.real_acl_data: Optional[ACLData] = ACLData([],{},())
        self.expected_acl_data: ACLData = expected_acl_data

    def get_unsanitized_element_report(self)->None:
        print("> Elements that are not contacting ACL:")
        if not self.element_not_contacting_acl:
            print("-")
        else:
            for i in range(len(self.element_not_contacting_acl)):
                # Untuk kasus memang tidak perlu ada pengecekan
                extra  = ""
                try:
                    key = self.element_not_contacting_acl[i].split("(")[0]
                    if self.expected_acl_data.service_acl[key]==self.real_acl_data.principal_list:
                        extra = " | Possibily doesn't need control access?"
                except KeyError:
                    pass
                print(f"{i+1}. {self.element_not_contacting_acl[i]}{extra}")
        print()

    def get_acl_table(self)->None:
        print("> Real ACL Table:")
        if not self.real_acl_data.service_acl:
            print("-")
        else:
            for key,value in self.real_acl_data.service_acl.items():
                if value =='*':
                    value = ",".join(self.real_acl_data.principal_list)
                print(f"{key}: {value}")
        print()
        print("> Potential Broken ACL:")
        i = 0
        for key,value in self.real_acl_data.service_acl.items():
            try:
                if set(self.expected_acl_data.service_acl[key])!=set(self.real_acl_data.service_acl[key]):
                    # Discrepancy
                    set_expected = set(self.expected_acl_data.service_acl[key])
                    set_real = set(self.real_acl_data.service_acl[key])
                    discrepancy = list((set_expected - set_real).union(set_real - set_expected))
                    print(f"{i+1}.{key} | Principal list difference: [{','.join(discrepancy)}]")
                    i+=1
            except KeyError:
                print(f"{i+1}.{key} is not found")
                i+=1
            except AttributeError:
                format_log("Unexpected error. Some ACL has null values!")
        # Gak ada yang broken
        if i==0:
            print("-")
        print()

    def add_unsanitized_routes(self,routes:list[str])->None:
        self.element_not_contacting_acl = routes
    def add_acl_data(self,acl_data:ACLData)->None:
        self.real_acl_data = acl_data